package com.malk.hangshi.controller;

import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilMap;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.aliwork.YDClient;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/hangshi")
public class HSController {

    @Autowired
    private YDClient ydClient;

    /**
     * 全局查询子表单
     */
    @PostMapping("query-all-details")
    McR queryAll(@RequestBody Map data) {

        log.info("全局查询子表单, {}", data);
        McException.assertParamException_Null(data, "condition", "formUuid", "compId");

        List conditions = Arrays.asList(UtilMap.map("key, value, type, operator, componentName", data.get("compId"), data.get("condition"), "TEXT", "contains", "TableField"));

        YDParam ydParam = YDParam.builder()
                .formUuid(String.valueOf(data.get("formUuid")))
                .searchCondition(JSON.toJSONString(conditions))
                .build();
        DDR_New ddr_new = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_list_all);
        return McR.success(ddr_new);
    }
}
