package com.malk.minjiaoyuan.controller;

import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilMap;
import com.malk.minjiaoyuan.service.MJYService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Contacts;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Profile;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 指定运行环境
 *
 * @Profile("prod")：一般添加于方法和类，标注该方法为指定环境运行 —>  若未找到指定环境会报错，多个环境与 @ActiveProfiles 一致
 */
@Profile({"dev"})
@Slf4j
@RestController
@RequestMapping("/minjiaoyuan")
public class TestControl {


    @Autowired
    private YDClient ydClient;

    @Autowired
    private YDConf ydConf;

    @Autowired
    private MJYService mjyService;

    @PostMapping("test2")
    McR test2() {
        // 修改评选进修编号
        String formInstanceId = "cefb90d5-9e8d-4cad-9fad-ac66d8f06362";
        YDParam ydParam = YDParam.builder()
                .formInstanceId(formInstanceId)
                .build();
        ydParam.setUpdateFormDataJson(JSON.toJSONString(UtilMap.map("selectField_lgf4ppa6", "骨干后备")));
        ydClient.operateData(ydParam, YDConf.FORM_OPERATION.update);
        return McR.success();
    }

    @PostMapping("test")
    McR test() {

        String formInstanceId = "98c7a6c9-bbbb-49e8-9838-f9f670e07859"; // 上海市金汇高级中学
//        String formInstanceId = "9c256687-cdee-4ce8-bca6-99f574d81a97"; // 闵行区七宝中心幼儿园
//        String formInstanceId = "60e7008a-6f11-410a-8019-d24be8c36abe"; // 上海市闵行区七宝幼儿园
//        String formInstanceId = "808370ff-dfc3-44f0-960e-da5b7c77defb"; // 上海市七宝中学附属鑫都实验中学
//        String formInstanceId = "86f436ae-0d19-4d6b-a909-346e1c30139e"; // 闵行区实验小学
//        String formInstanceId = "11c6fb7b-0a8e-4595-b1cf-0a7648316eff"; // 上海市七宝实验小学
//        String formInstanceId = "6f813646-d2c3-40f3-a72b-bf4fd2175724"; // 上海市民办文绮中学
//        String formInstanceId = "4808e60e-d645-4ca3-895a-8bf9b582aa3a"; // 上海师范大学康城实验学校
//        String formInstanceId = "616b546b-a41b-47df-8283-a6c719ca317c"; // 上海市闵行区爱博果果幼儿园
//        String formInstanceId = "9e380af2-da2d-493e-8a37-39a685e952b1"; // 上海市闵行区颛桥中学
//        String formInstanceId = "44b0a12d-b10f-4081-bbd7-2107427c675e"; // 上海市七宝中学


        // 学校申报数据
        YDParam ydParam = YDParam.builder()
                .formInstanceId(formInstanceId)
                .build();
        Map approveData = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_id).getFormData();
        List<Map> details = (List<Map>) approveData.get("tableField_lgiacs44");
        // 匹配申报数据
        ydParam.setFormInstanceId("");
        for (Map detail : details) {
            ydParam.setSearchFieldJson(JSON.toJSONString(UtilMap.map("textField_lgf4ppax", detail.get("textField_lgialujb"))));
//            if (String.valueOf(detail.get("employeeField_lgialujd")).contains("刘欣")) {
//                detail.put("textField_lgialujb", "120111015278");
//                ydParam.setSearchFieldJson(JSON.toJSONString(UtilMap.map("textField_lgf4ppax", "120111015278")));
//            }
            ydParam.setApprovedResult("agree");
            ydParam.setFormUuid("FORM-AC666081555ANZAZ6D4IVCQLY5Y12P4ZSRTGLVD");
            DDR_New ddr_new = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_search_process);
            Map data = ((List<Map>) ddr_new.getData()).get(0);
            Map formData = (Map) data.get("data");
            detail.put("associationFormField_lgiacs47", Arrays.asList(UtilMap.map("appType, formUuid, instanceId, title, formType, subTitle", ydConf.getAppType(), "FORM-AC666081555ANZAZ6D4IVCQLY5Y12P4ZSRTGLVD", data.get("processInstanceId"), formData.get("textField_lgs8ej3g"), "receipt", formData.get("textField_lgf4ppax"))));
            detail.put("employeeField_lgialujd", formData.get("employeeField_lgf4ppa7_id"));
//            detail.put("textField_lgivbkar", detail.get("radioField_lgialujc").equals("通过") ? "内通过" : "内拒绝");
            log.info("xxx, {}, {}", detail.get("employeeField_lgialujd"), ddr_new.getTotalCount());
            McException.assertAccessException(ddr_new.getTotalCount() != 1, "数据匹配异常");
        }

        Map update = UtilMap.map("tableField_lgiacs44", details);
        ydParam.setFormInstanceId(formInstanceId);
        ydParam.setUpdateFormDataJson(JSON.toJSONString(update));
        log.info("update, {}, {}", formInstanceId, JSON.toJSONString(update));
        ydClient.operateData(ydParam, YDConf.FORM_OPERATION.update);

        return McR.success();
    }

    // 清理数据 [教师档案]
    @PostMapping("delete")
    McR delete() {
//        YDParam ydParam = YDParam.builder()
//                .formUuid("FORM-AC666081555ANZAZ6D4IVCQLY5Y12P4ZSRTGLAE")
//                .build();
//        List<Map> list = mjyService.queryAllBySync(ydParam);
//        list.forEach(item -> {
//            ydParam.setFormInstanceId(String.valueOf(item.get("formInstanceId")));
//            ydClient.operateData(ydParam, YDConf.FORM_OPERATION.delete);
//        });
        return McR.success();
    }

    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Contacts ddClient_contacts;

    // 清理数据 [通讯录]
    @SneakyThrows
    @PostMapping("delete2")
    McR delete2() {

//        List<Long> deptList = ddClient.getDepartmentId_all(ddClient.getAccessToken());
//        for (Long deptId : deptList) {
//            List<String> userList = ddClient_contacts.listDepartmentUserId(ddClient.getAccessToken(), deptId.longValue());
//            for (String userId : userList) {
//                if (Arrays.asList("244859276337982323", "011063125337883469").contains(userId)) {
//                    continue;
//                }
//                YDParam ydParam = YDParam.builder()
//                        .formUuid("FORM-AC666081555ANZAZ6D4IVCQLY5Y12P4ZSRTGLAE")
//                        .searchFieldJson(JSON.toJSONString(UtilMap.map("textField_lftczqr5", userId)))
//                        .build();
//                DDR_New ddr_new = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_search_form);
//                if (ddr_new.getTotalCount() == 0) {
//                    ddClient_contacts.deleteUser(ddClient.getAccessToken(), userId);
//                    log.info("xxx, {}, {}, {}", userId, ddr_new.getTotalCount(), ddr_new.getData());
//                }
//                Thread.sleep(100); // 避免限流
//            }
//        }
        return McR.success();
    }


    @PostMapping("h3yun-http")
    McR http(@RequestBody Map data, @RequestParam("code") String code) {
        log.info("氚云http调试, code = {}, body = {}", code, data);
        return McR.success(UtilMap.map("name", "氚云http调试"));
    }
}
