package com.malk.service.aliwork.impl;

import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Slf4j
@Service
public class YDServiceImpl implements YDService {

    @Autowired
    private YDClient ydClient;

    /**
     * 操作数据 [异步] - 审批通过立即更新, 会无效
     */
    @Async
    @SneakyThrows
    @Override
    public Object operateData(YDParam ydParam, YDConf.FORM_OPERATION type) {
        Thread.sleep(3000);
        return ydClient.operateData(ydParam, type);
    }


    /**
     * 子表全部数据获取, 最大分页为50 [可考虑中间表思路]
     */
    @Override
    public List<Map> queryDetails(YDParam ydParam) {
        return _queryDetails(ydParam, new ArrayList<>());
    }

    // 递归查询
    private List<Map> _queryDetails(YDParam ydParam, List<Map> details) {
        ydParam.setPageSize(50);
        DDR_New ddr_new = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_details);
        details.addAll((List<Map>) ddr_new.getData());
        if (ddr_new.getTotalCount() != details.size()) {
            ydParam.setPageNumber(ydParam.getPageNumber() + 1);
            _queryDetails(ydParam, details);
        }
        return details;
    }
}
